com.google.appengine.api.search.query

## Interface QueryTreeVisitor<T extends QueryTreeContext<T>>

- Type Parameters:
    `T` - the type of the context object accompanying visited tree nodes.

      public interface QueryTreeVisitor<T extends QueryTreeContext<T>>

  Defines an interface of the visitor invoked by the walker.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `visitConjunction(Tree node, T context)` Visits a node that represents a conjunction (logical and) of conditions.
    `void` | `visitContains(Tree node, T context)` Visits a node that represents that a field must contain a value.
    `void` | `visitDisjunction(Tree node, T context)` Visits a node that represents a disjunction (logical or) of conditions.
    `void` | `visitEqual(Tree node, T context)` Visits a node that represents that a field value must be greater than or equal to some specified value.
    `void` | `visitFunction(Tree node, T context)` Visits a node that represents a function computed on some arguments.
    `void` | `visitFuzzy(Tree node, T context)` Visits a node that represents a text field that is subject to query rewrite.
    `void` | `visitGlobal(Tree node, T context)` Visits a node that represents a global field.
    `void` | `visitGreaterOrEqual(Tree node, T context)` Visits a node that represents an inequality between a field and value.
    `void` | `visitGreaterThan(Tree node, T context)` Visits a node that represents that a field value must be greater than some specified value.
    `void` | `visitLessOrEqual(Tree node, T context)` Visits a node that represents that a field value must be less than or equal to some specified value.
    `void` | `visitLessThan(Tree node, T context)` Visits a node that represents that a field value must be less than some specified value.
    `void` | `visitLiteral(Tree node, T context)` Visits a node that represents a text field that must not be altered.
    `void` | `visitNegation(Tree node, T context)` Visits a node that represents a negation of conditions.
    `void` | `visitOther(Tree node, T context)` Catch-all method for future type of query nodes.
    `void` | `visitSequence(Tree node, T context)` Visits a node that represents a sequence of expressions.
    `void` | `visitValue(Tree node, T context)` Visits a node that represents a constant value.

- - ### Method Detail

    - #### visitSequence

          void visitSequence(Tree node,
                             T context)

      Visits a node that represents a sequence of expressions.

    - #### visitConjunction

          void visitConjunction(Tree node,
                                T context)

      Visits a node that represents a conjunction (logical and) of conditions.

    - #### visitDisjunction

          void visitDisjunction(Tree node,
                                T context)

      Visits a node that represents a disjunction (logical or) of conditions.

    - #### visitNegation

          void visitNegation(Tree node,
                             T context)

      Visits a node that represents a negation of conditions.

    - #### visitFuzzy

          void visitFuzzy(Tree node,
                          T context)

      Visits a node that represents a text field that is subject to query rewrite.

    - #### visitLiteral

          void visitLiteral(Tree node,
                            T context)

      Visits a node that represents a text field that must not be altered.

    - #### visitLessThan

          void visitLessThan(Tree node,
                             T context)

      Visits a node that represents that a field value must be less than some specified value.

    - #### visitLessOrEqual

          void visitLessOrEqual(Tree node,
                                T context)

      Visits a node that represents that a field value must be less than or equal to some specified value.

    - #### visitGreaterThan

          void visitGreaterThan(Tree node,
                                T context)

      Visits a node that represents that a field value must be greater than some specified value.

    - #### visitGreaterOrEqual

          void visitGreaterOrEqual(Tree node,
                                   T context)

      Visits a node that represents an inequality between a field and value.

    - #### visitEqual

          void visitEqual(Tree node,
                          T context)

      Visits a node that represents that a field value must be greater than or equal to some specified value.

    - #### visitContains

          void visitContains(Tree node,
                             T context)

      Visits a node that represents that a field must contain a value.

    - #### visitValue

          void visitValue(Tree node,
                          T context)

      Visits a node that represents a constant value.

    - #### visitFunction

          void visitFunction(Tree node,
                             T context)

      Visits a node that represents a function computed on some arguments.

    - #### visitGlobal

          void visitGlobal(Tree node,
                           T context)

      Visits a node that represents a global field.

    - #### visitOther

          void visitOther(Tree node,
                          T context)

      Catch-all method for future type of query nodes.